00001 ! This Application demonstrates SQLIsam.! !A utility created by Mills Enterprise !:
      ! In order to Use this application, you must have a DSN called Northwind setup !:
      ! Name = Northwind !:
      ! Server=[Server URL] !:
      ! Login Name=GomezL_SQLIsam !:
      ! password=Mills
00002 ! Note: For simplicity, this demo will work with a local NORTHWIND.MDB table.!:
      ! Please create an ODBC DSN called Northwind!:
      ! GUI Mode is required as a COMBO BOX & GRID CONTROLS are used.
00003 EXECUTE 'con gui on'
00010 ! [Define Libraries]
00020 LIBRARY "Context\Context": FNOPEN_SQL,FNGETHANDLE,FNGET_VAR$
00030 ! DEF LIBRARY FNOPEN_SQL(SQL_HANDLE,SQL$*4096,DSN$*256,&SQL_FORMC$,&SQL_FORMN$,&SQL_FORMALL$,MAT SQL_FIELDSC$,MAT SQL_FIELDSN$,MAT SQL_DATA$,MAT SQL_DATA;PROMPT_USER,USER_NAME$*256,PASSWORD$*256) !:
      ! Library that uses SQLISAM.EXE to perform a SQL command against a DSN Source !:
      ! Returns = Total Number of Fields in result set or (-1000 for Error)
00040 ! SQL_HANDLE = File Handle to use for the query !:
      ! SQL$ = SQL Query to execute against Data Source!:
      ! SQL_FORMC$ = Form Statement to Read Character Data !:
      ! SQL_FORMN$ = Form Statement to Read Numeric Data !:
      ! SQL_FORMALL$ = Form Statement to Read Both Character and Numeric Data !:
      ! MAT SQL_FIELDSC$ = Array containing the Character field names!:
      ! MAT SQL_FIELDSN$ = Array containing the Numeric field names
00050 ! MAT SQL_DATA$ = Array That will be used to Read Character fields (Redimensioned correctly)!:
      ! MAT SQL_DATA = Array That will be used to Read Numeric fields (Redimensioned correctly)
00060 ! OPTIONAL FIELDS!:
      ! PROMPT_USER = Set to 1 to prompt the user for Name & Password !:
      ! or USER_NAME$ & PASSWORD$ = User Name & Password to access the DB.
00070 ! DEF LIBRARY FNGETHANDLE!:
      ! Library returns the next avialable File Handle (Starts with 999 and counts backwards)
00080 ! DEF LIBRARY FNGET_VAR$*128(UNQ$, MAT FIELDSC$, MAT FIELDSN$)!:
      ! Library that creates Local BR Variables based on the field names provided in the Characte & Numeric Arrays
00090 ! UNQ$ = The Unique "Prefix" to be used for the variable Names - For example "Customers"!:
      ! MAT FIELDSC$ = Array containing a list of Character field Names. (Usually provided by FNOPEN_SQL)!:
      ! MAT FIELDSN$ = Array containing a list of Numeric field Names. (Usually provided by FNOPEN_SQL)
00099 ! A Few Sample Variables created for this application!:
      ! CUSTOMERS_CUSTOMERID  - Sample use: LET CUSTOMER_ID$(CUSTOMER)=CUSTOMERS_DATA$(CUSTOMERS_CUSTOMERID) !:
      ! INVOICES_ORDERID - Sample User: INVOICES_ORDERID(_INVOICES)=INVOICES_DATA(INVOICES_ORDERID)
00200 PRINT NEWPAGE
00210 PRINT FIELDS "1,1,CC 80": "Northwinds Invoices Database Demo" !:
      LET SCR_FREEZE
00220 LET CRLF$=CHR$(13)&CHR$(10)
00230 ! The Following Lines Populate the Necessary information to setup the grid for the Order Details.
00240 LET INV_GRID_HEADINGS$(1)="Order ID" !:
      LET INV_GRID_HEADINGS$(2)="Order Date" !:
      LET INV_GRID_HEADINGS$(3)="Ship Date" !:
      LET INV_GRID_HEADINGS$(4)="Product Name" !:
      LET INV_GRID_HEADINGS$(5)="Freight" !:
      LET INV_GRID_HEADINGS$(6)="Total Price"
00250 LET INV_GRID_WIDTHS(1)=8 !:
      LET INV_GRID_WIDTHS(2)=10 !:
      LET INV_GRID_WIDTHS(3)=10 !:
      LET INV_GRID_WIDTHS(4)=30 !:
      LET INV_GRID_WIDTHS(5)=10 !:
      LET INV_GRID_WIDTHS(6)=10
00260 LET INV_GRID_FORMS$(1)="N 8,[T]" !:
      LET INV_GRID_FORMS$(2)="Date(MM/DD/CCYY),[T]" !:
      LET INV_GRID_FORMS$(3)="Date(MM/DD/CCYY),[T]" !:
      LET INV_GRID_FORMS$(4)="C 80,[T]" !:
      LET INV_GRID_FORMS$(5)="N 12.2,[T]" !:
      LET INV_GRID_FORMS$(6)="N 12.2,[T]"
00270 LET INV_GRID_HANDLE$="9,1,GRID 14/80"
00500 ! The Following Lines performs a SQL query against the Northwind database using the CUSTOMERS tables !:
      ! CUSTOMERS_Result contains the number of fields returned, but is basically ignored!:
      ! CUSTOMERS_HANDLE will point to BR Internal Data File created by SQL_ISAM !:
      ! All of the "CUSTOMERS_" Variables and Arrays will be defined by this function as well. !:
      ! If customers_handle<0 Then the Query Failed
00510 LET CUSTOMERS_RESULT=FNOPEN_SQL(CUSTOMERS_HANDLE:=FNGETHANDLE,SQL$:="select CUSTOMERID, CompanyName,Phone,Country,PostalCode from Customers",DSN$:="Northwind",CUSTOMERS_FORMC$,CUSTOMERS_FORMN$,CUSTOMERS_FORMALL$,MAT CUSTOMERS_FIELDSC$,MAT CUSTOMERS_FIELDSN$,MAT CUSTOMERS_DATA$,MAT CUSTOMERS_DATA,PROMPT_USER=0,USER_NAME$:="GomezL_SQLIsam",PASSWORD$:="mills")
00520 IF CUSTOMERS_HANDLE<=0 THEN PRINT "Warning Problem Opening the Northwind Database" !:
      STOP 
00530 ! Local BR Variables are Created CUSTOMERS_[FIELD NAME]
00540 EXECUTE "*Subproc "&FNGET_VAR$("Customers", MAT CUSTOMERS_FIELDSC$, MAT CUSTOMERS_FIELDSN$)
00600 ! Populate Arrays with the Customer ID & Demographic Information!:
      ! Simply Loop through customers_handle using a READ on a BR INTERNAL DATA FILE
00610 LET CUSTOMERS=LREC(CUSTOMERS_HANDLE) !:
      MAT CUSTOMER_ID$(CUSTOMERS) !:
      MAT CUSTOMER$(CUSTOMERS)
00620 DO 
00630 READ #CUSTOMERS_HANDLE,USING CUSTOMERS_FORMC$,RELEASE: MAT CUSTOMERS_DATA$ EOF XIT_READ_CUSTOMERS
00640 LET CUSTOMER+=1 !:
      LET CUSTOMER_ID$(CUSTOMER)=CUSTOMERS_DATA$(CUSTOMERS_CUSTOMERID) !:
      LET CUSTOMER$(CUSTOMER)=RTRM$(CUSTOMERS_DATA$(CUSTOMERS_COMPANYNAME))&CRLF$&RTRM$(CUSTOMERS_DATA$(CUSTOMERS_PHONE))&CRLF$&RTRM$(CUSTOMERS_DATA$(CUSTOMERS_COUNTRY))&" "&RTRM$(CUSTOMERS_DATA$(CUSTOMERS_POSTALCODE))
00650 LOOP 
00660 XIT_READ_CUSTOMERS: CLOSE #CUSTOMERS_HANDLE: 
01000 ! Setup the Screen to display Customer information
01010 OPEN #101: "SROW=5,SCOL=20,ROWS=4,COLS=30",DISPLAY,OUTIN 
01020 PRINT FIELDS "7,1,CC 8,[W],B0;7,10,CC 8,[W],B99": "OK","CLOSE"
01100 ! Select the desired Customer (Default to the 1st customer) (Start of Loop)
01110 GET_CUSTOMER_ID: ! Get Customer ID #
01120 IF SRCH(MAT CUSTOMER_ID$,CUSTOMER_ID$)<=0 THEN LET CUSTOMER_ID$=CUSTOMER_ID$(1)
01130 PRINT FIELDS "5,1,CR 10;5,12,COMBO 5/5,=Select": "Customer:",MAT CUSTOMER_ID$
01140 RINPUT FIELDS "5,12,COMBO 5/5,[D]STAE",ATTR '[A]': CUSTOMER_ID$ !:
      LET SCR_FREEZE
01150 IF FKEY=93 OR FKEY=99 THEN STOP 
01200 ! Find the Selected customer$ using CUSTOMER_ID$ and DSIPLAY Demographics
01210 LET SCR_FREEZE !:
      LET CUSTOMER_ID=SRCH(MAT CUSTOMER_ID$,CUSTOMER_ID$) !:
      IF CUSTOMER_ID<=0 THEN GOTO 1140
01220 PRINT #101,FIELDS "1,1,C 120 ,[P]SP": CUSTOMER$(CUSTOMER_ID)
01300 ! Create a GRID that will populate the Order Information for the selected customer.
01310 PRINT FIELDS INV_GRID_HANDLE$&",HEADERS,[TABS]": (MAT INV_GRID_HEADINGS$,MAT INV_GRID_WIDTHS,MAT INV_GRID_FORMS$)
02000 ! The Following Lines performs a SQL query against the Northwind database using the ORDERS tables !:
      ! where CUSTOMERID='"&CUSTOMER_ID$&"'!:
      ! INVOICES_Result contains the number of fields returned, but is basically ignored!:
      ! INVOICES_HANDLE will point to BR Internal Data File created by SQL_ISAM !:
      ! All of the "INVOICES_" Variables and Arrays will be re-defined by this function as well. !:
      ! If INVOICES_HANDLE<0 Then the Query Failed
02010 LET INVOICES_RESULT=FNOPEN_SQL(INVOICES_HANDLE:=FNGETHANDLE,SQL$:="select CUSTOMERID, FREIGHT, ExtendedPrice,ProductName, ORDERID, OrderDate,ShippedDate from Invoices where CUSTOMERID='"&CUSTOMER_ID$&"'",DSN$:="Northwind",INVOICES_FORMC$,INVOICES_FORMN$,INVOICES_FORMALL$,MAT INVOICES_FIELDSC$,MAT INVOICES_FIELDSN$,MAT INVOICES_DATA$,MAT INVOICES_DATA,PROMPT_USER=0,USER_NAME$:="GomezL_SQLIsam",PASSWORD$:="mills")
02020 IF INVOICES_HANDLE<=0 THEN PRINT "Warning Problem Opening the Northwind Database" !:
      STOP 
02030 ! Local BR Variables are Created INVOICES_[FIELD NAME]
02040 EXECUTE "*Subproc "&FNGET_VAR$("Invoices", MAT INVOICES_FIELDSC$, MAT INVOICES_FIELDSN$)
02100 ! Populate Arrays with the detailed INVOICES iformation!:
      ! Simply Loop through customers_handle using a READ on a BR INTERNAL DATA FILE!:
      ! Seperate Arrays are created for each column to be used in the Grid
02110 LET _INVOICES=0
02120 DO 
02130 READ #INVOICES_HANDLE,USING INVOICES_FORMC$,RELEASE: MAT INVOICES_DATA$ EOF XIT_READ_INVOICES
02140 REREAD #INVOICES_HANDLE,USING INVOICES_FORMN$,RELEASE: MAT INVOICES_DATA
02150 LET _INVOICES+=1 !:
      MAT INVOICES_ORDERID(_INVOICES) !:
      MAT INVOICES_ORDERDATE(_INVOICES) !:
      MAT INVOICES_SHIPPEDDATE(_INVOICES) !:
      MAT INVOICES_PRODUCTNAME$(_INVOICES) !:
      MAT INVOICES_FREIGHT(_INVOICES) !:
      MAT INVOICES_EXTENDEDPRICE(_INVOICES)
02160 LET INVOICES_ORDERID(_INVOICES)=INVOICES_DATA(INVOICES_ORDERID)
02170 LET INVOICES_ORDERDATE(_INVOICES)=VAL(INVOICES_DATA$(INVOICES_ORDERDATE))
02180 LET INVOICES_SHIPPEDDATE(_INVOICES)=VAL(INVOICES_DATA$(INVOICES_SHIPPEDDATE))
02190 LET INVOICES_PRODUCTNAME$(_INVOICES)=INVOICES_DATA$(INVOICES_PRODUCTNAME)
02200 LET INVOICES_FREIGHT(_INVOICES)=VAL(INVOICES_DATA$(INVOICES_FREIGHT))
02210 LET INVOICES_EXTENDEDPRICE(_INVOICES)=VAL(INVOICES_DATA$(INVOICES_EXTENDEDPRICE))
02220 LOOP 
02230 XIT_READ_INVOICES: CLOSE #INVOICES_HANDLE: 
03000 ! DISPLAY INVOICES ON GRID
03010 PRINT FIELDS INV_GRID_HANDLE$&",=": ( MAT INVOICES_ORDERID, MAT INVOICES_ORDERDATE, MAT INVOICES_SHIPPEDDATE, MAT INVOICES_PRODUCTNAME$, MAT INVOICES_FREIGHT,MAT INVOICES_EXTENDEDPRICE )
04000 ! Loop to start
04010 GOTO GET_CUSTOMER_ID
90000 ! The Following Lines contain the necessary "DIM" Statements for all the Variables used by this application.
90010 ! DIM Variables used to call FNOPEN_SQL
90020 DIM SQL$*1024,DSN$*80,USER_NAME$*80,PASSWORD$*80
90030 ! DIM Variables that will be used to store Arrays containing all customers
90040 DIM CUSTOMER_ID$(1)*20,CUSTOMER$(1)*256,CUSTOMER$*256
90050 ! DIM Variables that will be used to store Arrays containing all orders for a particular customerDIM Variables that will be used to store Arrays containing all orders for a particular customer
90060 DIM INVOICES_ORDERID(1),INVOICES_ORDERDATE(1),INVOICES_SHIPPEDDATE(1),INVOICES_PRODUCTNAME$(1)*80,INVOICES_FREIGHT(1),INVOICES_EXTENDEDPRICE(1)
90070 ! DIM Variables that will be used to create the GRID used to display all orders for a particular customer
90080 DIM INV_GRID_HEADINGS$(6)*32,INV_GRID_WIDTHS(6),INV_GRID_FORMS$(6)*32,INV_GRID_HANDLE$*80
90090 ! The following arrays are used to create the "SQL" Variables used by the various FNOPEN_SQL statements.
90100 DIM CUSTOMERS_FORMC$*2048,CUSTOMERS_FORMN$*2048,CUSTOMERS_FORMALL$*2048,CUSTOMERS_FIELDSC$(1)*30,CUSTOMERS_FIELDSN$(1)*30,CUSTOMERS_DATA$(1)*256,CUSTOMERS_DATA(1)
90110 DIM INVOICES_FORMC$*2048,INVOICES_FORMN$*2048,INVOICES_FORMALL$*2048,INVOICES_FIELDSC$(1)*30,INVOICES_FIELDSN$(1)*30,INVOICES_DATA$(1)*256,INVOICES_DATA(1)
