00001 PRINT NEWPAGE
00009 LET TAB$=CHR$(9)
00010 ! This routine assumes that context is in a directory called context !:
      ! Copy the Contents of Toold to the context folder !:
      ! ** Note: The Context Folder in the ODBC Development must have the ODBC application in order to import/maintain the Context DB !:
      ! For this reason, the context inside the ODBC dev environment should either be the original provided by CLS, or you should impo
00011 ! For this reason, the context inside the ODBC dev environment should either be the original provided by CLS, or you should impot the ODBC database into your own Context !:
      ! ** This is a bit of a Chicken before the Egg issue as the program uses the context database to build the context database
00015 DIM CSV_DATA$(1)*80,CSV_FIELDS$(1)*80,BUFF$*9999,CSV_LINE$*9999,CSV_KEY(9),CSV_CONTEXT_DATA$(1)*80,CSV_CONTEXT_FIELDS$(1)*80,CONTEXT$*99,FIELD_NAME$*15
00020 LIBRARY "CONTEXT\CONTEXT": FNCONTEXT,FNGET_VAR$,FNPACK_FORM$,FNOPEN_TABLE,FNOPEN_CSV,FNPARSE_CSV
00030 LET FNINIT_CONTEXT !:
      ! * Setup arrays and form statements for the various Context Files !:
      ! App !:
      ! Context !:
      ! File_App !:
      ! Record !:
      ! Rec_Link
00040 LET FNOPEN_CSV(CSV_HANDLE:=FNGETHANDLE_,"CONTEXT\FILEAPP.TXT",CSV_DELIMITER$,MAT CSV_FIELDS$,MAT CSV_DATA$)
00050 LET CSV_APP_ID=SRCH(MAT CSV_FIELDS$,"APP_ID")
00051 LET CSV_APP_NAME=SRCH(MAT CSV_FIELDS$,"APP_NAME")
00052 LET CSV_APP_PROGRAM=SRCH(MAT CSV_FIELDS$,"APP_PROGRAM")
00053 LET CSV_APP_DATA=SRCH(MAT CSV_FIELDS$,"APP_DATA")
00054 LET CSV_APP_SOURCE=SRCH(MAT CSV_FIELDS$,"APP_SOURCE")
00055 LET CSV_FILE_ID=SRCH(MAT CSV_FIELDS$,"FILE_ID")
00056 LET CSV_DESCRIPTION=SRCH(MAT CSV_FIELDS$,"DESCRIPTION")
00057 LET CSV_RECORD_ID=SRCH(MAT CSV_FIELDS$,"RECORD_ID")
00058 LET CSV_PREFIX=SRCH(MAT CSV_FIELDS$,"PREFIX")
00059 LET CSV_CONTEXT=SRCH(MAT CSV_FIELDS$,"CONTEXT")
00060 LET CSV_MASTER=SRCH(MAT CSV_FIELDS$,"MASTER")
00070 FOR _CSV_KEY=1 TO 9 !:
      LET CSV_KEY(_CSV_KEY)=SRCH(MAT CSV_FIELDS$,"KEY"&STR$(_CSV_KEY)) !:
      NEXT _CSV_KEY
00100 ! FILEAPP.TXT HAS BEEN OPENED, AND THE CSV_FIELDS HAVE BEEN MAPPED TO THE CSV_FIELDS ARRAY !:
      ! The following code will validate the required fields.
00110 IF CSV_APP_ID<=0 THEN PRINT "APP_ID - The code for the application is a mandatory field" !:
      PRINT "Please modify FILEAPP.TXT" !:
      STOP 
00111 IF CSV_FILE_ID<=0 THEN PRINT "file_ID - The code for the FILE_ID is a mandatory field" !:
      PRINT "Please modify FILEAPP.TXT" !:
      STOP 
00900 ! [Read The Next Item in the file]
00910 LINPUT #CSV_HANDLE: CSV_LINE$ EOF FINIS !:
      LET FNPARSE_CSV(CSV_LINE$,MAT CSV_DATA$,CSV_DELIMITER$) !:
      MAT CSV_DATA$(UDIM(CSV_FIELDS$))
01000 ! Make certain that the APP record has already been defined
01005 DIM APP_ID$*8
01010 IF APP_HANDLE<=0 THEN PRINT "Problem processing APP" !:
      STOP 
01020 LET APP_ID$=RPAD$(UPRC$(TRIM$(CSV_DATA$(CSV_APP_ID))),8)(1:8)
01030 MAT APP_DATA$=("") !:
      MAT APP_DATA=(0) !:
      READ #APP_HANDLE,USING APP_FORM_ALL$,KEY=APP_ID$: MAT APP_DATA$,MAT APP_DATA NOKEY 1040 !:
      GOTO 1100
01040 LET APP_DATA$(APP_APP_ID)=APP_ID$
01041 LET APP_DATA(APP_DATE_CHANGED)=DAYS(DATE)
01050 WRITE #APP_HANDLE,USING APP_FORM_ALL$: MAT APP_DATA$,MAT APP_DATA
01060 GOTO 1030
01100 ! Application Found
01110 LET FNCSV_PUT$(CSV_APP_NAME,APP_DATA$(APP_APP_NAME))
01111 LET FNCSV_PUT$(CSV_APP_PROGRAM,APP_DATA$(APP_APP_PROGRAM))
01112 LET FNCSV_PUT$(CSV_APP_DATA,APP_DATA$(APP_APP_DATA))
01113 LET FNCSV_PUT$(CSV_APP_SOURCE,APP_DATA$(APP_APP_SOURCE))
01190 REWRITE #APP_HANDLE,USING APP_FORM_ALL$: MAT APP_DATA$,MAT APP_DATA
01200 ! Make sure the FILE_APP exists
01210 IF FILE_APP_HANDLE<=0 THEN PRINT "Problem processing FILE_APP" !:
      STOP 
01220 LET FILE_ID$=RPAD$(UPRC$(TRIM$(CSV_DATA$(CSV_FILE_ID))),8)(1:8)
01230 MAT FILE_APP_DATA$=("") !:
      MAT FILE_APP_DATA=(0) !:
      READ #FILE_APP_HANDLE,USING FILE_APP_FORM_ALL$,KEY=APP_ID$&FILE_ID$: MAT FILE_APP_DATA$,MAT FILE_APP_DATA NOKEY 1240 !:
      GOTO 1300
01240 LET FILE_APP_DATA$(FILE_APP_APP_ID)=APP_ID$ !:
      LET FILE_APP_DATA$(FILE_APP_FILE_ID)=FILE_ID$
01241 LET FILE_APP_DATA(FILE_APP_DATE_CHANGED)=DAYS(DATE)
01250 WRITE #FILE_APP_HANDLE,USING FILE_APP_FORM_ALL$: MAT FILE_APP_DATA$,MAT FILE_APP_DATA
01260 GOTO 1230
01300 ! File Application Exists, populate the table values
01310 LET FNCSV_PUT$(CSV_DESCRIPTION,FILE_APP_DATA$(FILE_APP_DESCRIPTION))
01311 LET FNCSV_PUT$(CSV_APP_DATA,FILE_APP_DATA$(FILE_APP_APP_DIRECTORY))
01312 LET FNCSV_PUT$(CSV_MASTER,FILE_APP_DATA$(FILE_APP_MASTER))
01313 FOR _CSV_KEY=1 TO 9 !:
      LET FILE_APP_KEY=SRCH(MAT FILE_APP_FIELDSC$,"KY"&STR$(_CSV_KEY)) !:
      LET FNCSV_PUT$(CSV_KEY(_CSV_KEY),FILE_APP_DATA$(FILE_APP_KEY)) !:
      NEXT _CSV_KEY
01390 REWRITE #FILE_APP_HANDLE,USING FILE_APP_FORM_ALL$: MAT FILE_APP_DATA$,MAT FILE_APP_DATA
01400 ! Make sure the Record Exists !:
      ! ** Note: RECORD_ID will default to FILE_ID if not in data
01410 IF RECORD_HANDLE<=0 THEN PRINT "Problem processing RECORD" !:
      STOP 
01420 LET RECORD_ID$=RPAD$(UPRC$(TRIM$(CSV_DATA$(CSV_FILE_ID))),8)(1:8) !:
      IF TRIM$(RECORD_ID$)="" THEN !:
      LET RECORD_ID$=FILE_ID$
01430 MAT RECORD_DATA$=("") !:
      MAT RECORD_DATA=(0) !:
      READ #RECORD_HANDLE,USING RECORD_FORM_ALL$,KEY=APP_ID$&FILE_ID$&RECORD_ID$: MAT RECORD_DATA$,MAT RECORD_DATA NOKEY 1440 !:
      GOTO 1500
01440 LET RECORD_DATA$(RECORD_APP_ID)=APP_ID$ !:
      LET RECORD_DATA$(RECORD_FILE_ID)=FILE_ID$ !:
      LET RECORD_DATA$(RECORD_RECORD_ID)=RECORD_ID$
01441 LET RECORD_DATA(RECORD_DATE_CHANGED)=DAYS(DATE)
01450 WRITE #RECORD_HANDLE,USING RECORD_FORM_ALL$: MAT RECORD_DATA$,MAT RECORD_DATA
01460 GOTO 1430
01500 ! Record Exists, populate the table values
01510 LET FNCSV_PUT$(CSV_DESCRIPTION,RECORD_DATA$(RECORD_DESCRIPTION))
01511 LET FNCSV_PUT$(CSV_PREFIX,RECORD_DATA$(RECORD_FIELD_PREFIX)) !:
      IF TRIM$(RECORD_DATA$(RECORD_FIELD_PREFIX))="" THEN LET RECORD_DATA$(RECORD_FIELD_PREFIX)=TRIM$(RECORD_ID$)(1:3)
01590 REWRITE #RECORD_HANDLE,USING RECORD_FORM_ALL$: MAT RECORD_DATA$,MAT RECORD_DATA
01600 ! Populate Fields (If the Context Field Exists (Name of file to import!)
01610 LET CONTEXT$=TRIM$(CSV_DATA$(CSV_CONTEXT)) !:
      IF CONTEXT$="" THEN GOTO 8000
01620 IF POS(UPRC$(CONTEXT$),".TXT")<=0 THEN GOTO 7000
01625 IF CONTEXT_HANDLE<=0 THEN PRINT "Problem processing RECORD" !:
      STOP 
02000 LET LIST_POINTER=0 !:
      LET FNOPEN_CSV(CSV_CONTEXT_HANDLE:=FNGETHANDLE_,CONTEXT$,CSV_CONTEXT_DELIMITER$,MAT CSV_CONTEXT_FIELDS$,MAT CSV_CONTEXT_DATA$)
02001 LET CSV_CONTEXT_FIELD_NAME=SRCH(MAT CSV_CONTEXT_FIELDS$,"FIELD_NAME") !:
      LET CSV_CONTEXT_RECORD_POS=SRCH(MAT CSV_CONTEXT_FIELDS$,"RECORD_POS") !:
      LET CSV_CONTEXT_DISK_STORAGE=SRCH(MAT CSV_CONTEXT_FIELDS$,"DISK_STORAGE") !:
      LET CSV_CONTEXT_DTE_FMT=SRCH(MAT CSV_CONTEXT_FIELDS$,"DTE_FMT") !:
      LET CSV_CONTEXT_ORIG_CAPTION=SRCH(MAT CSV_CONTEXT_FIELDS$,"ORIG_CAPTION") !:
      LET CSV_CONTEXT_RECORD_LEN=SRCH(MAT CSV_CONTEXT_FIELDS$,"RECORD_LEN") !:
      LET CSV_CONTEXT_DECIMAL_POS=SRCH(MAT CSV_CONTEXT_FIELDS$,"DECIMAL_POS")
02005 IF CSV_CONTEXT_FIELD_NAME<=0 THEN !:
      PRINT "Field_Name is required for": LET FILE$(CSV_CONTEXT_HANDLE) !:
      STOP 
02006 IF CSV_CONTEXT_RECORD_POS<=0 THEN !:
      PRINT "Record_POS is required for": LET FILE$(CSV_CONTEXT_HANDLE) !:
      STOP 
02007 IF CSV_CONTEXT_DISK_STORAGE<=0 THEN !:
      PRINT "DISK_STORAGE is required for": LET FILE$(CSV_CONTEXT_HANDLE) !:
      STOP 
02008 IF CSV_CONTEXT_RECORD_LEN<=0 THEN !:
      PRINT "RECORD_LEN is required for": LET FILE$(CSV_CONTEXT_HANDLE) !:
      STOP 
02010 MAT CSV_CONTEXT_DATA$=("") !:
      LINPUT #CSV_CONTEXT_HANDLE: CSV_LINE$ EOF FINIS_CONTEXT !:
      LET FNPARSE_CSV(CSV_LINE$,MAT CSV_CONTEXT_DATA$,CSV_CONTEXT_DELIMITER$)
02020 LET FIELD_NAME$=RPAD$(UPRC$(TRIM$(CSV_CONTEXT_DATA$(CSV_CONTEXT_FIELD_NAME))),15)(1:15) !:
      LET RECORD_POS=0 !:
      LET RECORD_POS=VAL(CSV_CONTEXT_DATA$(CSV_CONTEXT_RECORD_POS)) CONV 2021
02021 IF RECORD_POS<=0 THEN PRINT "Warning, Record Pos = ";RECORD_POS;' for ';APP_ID$&FILE_ID$&CONTEXT_ID$&FIELD_NAME$ !:
      PAUSE  !:
      GOTO 2010 !:
      ! ** Note: Record_POS not Field Name is the key handle for updating a field !:
      ! This means that a "New Pos" will create a new field"
02030 MAT CONTEXT_DATA$=("") !:
      MAT CONTEXT_DATA=(0) !:
      READ #CONTEXT_HANDLE,USING CONTEXT_FORM_ALL$,KEY=APP_ID$&FILE_ID$&RECORD_ID$&CNVRT$('BH 2',RECORD_POS): MAT CONTEXT_DATA$,MAT CONTEXT_DATA NOKEY 2040 !:
      GOTO 2100
02040 LET CONTEXT_DATA$(CONTEXT_APP_ID)=APP_ID$ !:
      LET CONTEXT_DATA$(CONTEXT_FILE_ID)=FILE_ID$ !:
      LET CONTEXT_DATA$(CONTEXT_RECORD_ID)=RECORD_ID$ !:
      LET CONTEXT_DATA$(CONTEXT_FIELD_NAME)=FIELD_NAME$
02041 LET CONTEXT_DATA(CONTEXT_RECORD_POS)=RECORD_POS !:
      LET CONTEXT_DATA(CONTEXT_DATE_CHANGED)=DAYS(DATE)
02050 WRITE #CONTEXT_HANDLE,USING CONTEXT_FORM_ALL$: MAT CONTEXT_DATA$,MAT CONTEXT_DATA
02060 GOTO 2030
02100 LET LIST_POINTER+=1 !:
      LET CONTEXT_DATA(CONTEXT_LIST_POINTER)=LIST_POINTER !:
      ! Field Found in Context
02110 LET FNCSV_CONTEXT_PUT$(CSV_CONTEXT_DISK_STORAGE,CONTEXT_DATA$(CONTEXT_DISK_STORAGE)) !:
      LET _SPACE=POS(CONTEXT_DATA$(CONTEXT_DISK_STORAGE)," ") !:
      IF _SPACE>0 THEN LET CONTEXT_DATA$(CONTEXT_DISK_STORAGE)(_SPACE:999)=""
02111 LET FNCSV_CONTEXT_PUT$(CSV_CONTEXT_DTE_FMT,CONTEXT_DATA$(CONTEXT_DTE_FMT))
02112 LET FNCSV_CONTEXT_PUT$(CSV_CONTEXT_ORIG_CAPTION,CONTEXT_DATA$(CONTEXT_ORIG_CAPTION))
02113 ! LET FNCSV_CONTEXT_PUT(CSV_CONTEXT_RECORD_POS,CONTEXT_DATA(CONTEXT_RECORD_POS)) !:
      ! ** Already set, so do not update
02114 LET FNCSV_CONTEXT_PUT(CSV_CONTEXT_RECORD_LEN,CONTEXT_DATA(CONTEXT_RECORD_LEN))
02115 LET FNCSV_CONTEXT_PUT(CSV_CONTEXT_DECIMAL_POS,CONTEXT_DATA(CONTEXT_DECIMAL_POS))
02116 LET CONTEXT_DATA$(CONTEXT_DISK_STORAGE)=TRIM$(CONTEXT_DATA$(CONTEXT_DISK_STORAGE))&" "&STR$(VAL(STR$(CONTEXT_DATA(CONTEXT_RECORD_LEN))&"."&STR$(CONTEXT_DATA(CONTEXT_DECIMAL_POS))))
02190 REWRITE #CONTEXT_HANDLE,USING CONTEXT_FORM_ALL$: MAT CONTEXT_DATA$,MAT CONTEXT_DATA
02199 GOTO 2010 !:
      ! * Read the next field
02200 FINIS_CONTEXT: CLOSE #CSV_CONTEXT_HANDLE: 
02210 GOTO 9000
06999 PAUSE 
07000 PRINT "WARNING - ";CONTEXT$;" Not supported for File Layouts" !:
      PAUSE 
08000 ! End of Import
08999 ! PAUSE
09000 GOTO 910 !:
      ! Read Next Record
09990 FINIS: PRINT "Import Complete" !:
      STOP 
09999 STOP 
11000 DEF FNCSV_PUT$(CSV_FIELD,&DESTINATION$)
11010 IF CSV_FIELD>0 AND TRIM$(CSV_DATA$(CSV_FIELD))<>"" THEN !:
      LET DESTINATION$=CSV_DATA$(CSV_FIELD)
11099 FNEND 
11100 DEF FNCSV_CONTEXT_PUT$(CSV_CONTEXT_FIELD,&DESTINATION$)
11110 IF CSV_CONTEXT_FIELD>0 AND TRIM$(CSV_CONTEXT_DATA$(CSV_CONTEXT_FIELD))<>"" THEN !:
      LET DESTINATION$=CSV_CONTEXT_DATA$(CSV_CONTEXT_FIELD)
11199 FNEND 
11200 DEF FNCSV_CONTEXT_PUT(CSV_CONTEXT_FIELD,&DESTINATION)
11205 LET CSV_CONTEXT_VALUE=0 !:
      IF CSV_CONTEXT_FIELD>0 THEN !:
      LET CSV_CONTEXT_VALUE=VAL(CSV_CONTEXT_DATA$(CSV_CONTEXT_FIELD)) CONV 11210
11210 IF CSV_CONTEXT_FIELD>0 AND CSV_CONTEXT_VALUE<>0 THEN !:
      LET DESTINATION=CSV_CONTEXT_VALUE
11299 FNEND 
12000 DEF FNINIT_CONTEXT
12001 ! ###_DATA$ & ###_DATA are arrays to contains data fields for each table !:
      ! ###_FIELDSC$ & ###_FIELDSN$ are arrays that contain the field names (Char & Num) !:
      ! ###_FORMC$ & ###_FORMN$ contain the Form statements to read Char & Num
12010 LET FNCONTEXT("ODBC","APP","",MAT APP_DATA$,MAT APP_DATA,MAT APP_FIELDSC$,MAT APP_FIELDSN$,APP_FORMC$,APP_FORMN$,APP_FORM_ALL$)
12011 EXECUTE "*SubProc "&FNGET_VAR$("APP", MAT APP_FIELDSC$, MAT APP_FIELDSN$)
12012 LET APP_HANDLE=FNOPEN_TABLE("ODBC","APP",MAT APP_HANDLES)
12020 LET FNCONTEXT("ODBC","CONTEXT","",MAT CONTEXT_DATA$,MAT CONTEXT_DATA,MAT CONTEXT_FIELDSC$,MAT CONTEXT_FIELDSN$,CONTEXT_FORMC$,CONTEXT_FORMN$,CONTEXT_FORM_ALL$)
12021 EXECUTE "*SubProc "&FNGET_VAR$("CONTEXT", MAT CONTEXT_FIELDSC$, MAT CONTEXT_FIELDSN$)
12022 LET CONTEXT_HANDLE=FNOPEN_TABLE("ODBC","context",MAT CONTEXT_HANDLES)
12030 LET FNCONTEXT("ODBC","FILEAPP","",MAT FILE_APP_DATA$,MAT FILE_APP_DATA,MAT FILE_APP_FIELDSC$,MAT FILE_APP_FIELDSN$,FILE_APP_FORMC$,FILE_APP_FORMN$,FILE_APP_FORM_ALL$)
12031 EXECUTE "*SubProc "&FNGET_VAR$("FILE_APP", MAT FILE_APP_FIELDSC$, MAT FILE_APP_FIELDSN$)
12032 LET FILE_APP_HANDLE=FNOPEN_TABLE("ODBC","FILEAPP",MAT FILE_APP_HANDLES)
12040 LET FNCONTEXT("ODBC","RECORD","",MAT RECORD_DATA$,MAT RECORD_DATA,MAT RECORD_FIELDSC$,MAT RECORD_FIELDSN$,RECORD_FORMC$,RECORD_FORMN$,RECORD_FORM_ALL$)
12041 EXECUTE "*SubProc "&FNGET_VAR$("RECORD", MAT RECORD_FIELDSC$, MAT RECORD_FIELDSN$)
12042 LET RECORD_HANDLE=FNOPEN_TABLE("ODBC","RECORD",MAT RECORD_HANDLES)
12050 LET FNCONTEXT("ODBC","RECLINK","",MAT REC_LINK_DATA$,MAT REC_LINK_DATA,MAT REC_LINK_FIELDSC$,MAT REC_LINK_FIELDSN$,REC_LINK_FORMC$,REC_LINK_FORMN$,REC_LINK_FORM_ALL$)
12051 EXECUTE "*SubProc "&FNGET_VAR$("RECLINK", MAT REC_LINK_FIELDSC$, MAT REC_LINK_FIELDSN$)
12052 LET REC_LINK_HANDLE=FNOPEN_TABLE("ODBC","RECLINK",MAT REC_LINK_HANDLES)
12099 FNEND 
12100 DEF LIBRARY FNOPEN_TABLE(APPLICATION$,FILENAME$,MAT TABLE_HANDLES)
12101 ! Application = Application Code !:
      ! Filename = File Name Code !:
      ! MAT Table Handles = Handles Assigned to each of the table/indexes
12102 MAT TABLE_HANDLES(_TABLE_HANDLE:=0)=(0)
12105 DIM APP_DATA$*33,OPEN_MASTER$*64,OPEN_KEY$(9)*64
12106 LET APPLICATION$=RPAD$(UPRC$(APPLICATION$),8)(1:8) !:
      LET FILENAME$=RPAD$(UPRC$(FILENAME$),8)(1:8)
12110 IF FILE_APP_HND=0 THEN LET FILE_APP_HND=FNGETHANDLE_
12120 IF FILE(FILE_APP_HND)<0 THEN !:
      OPEN #(FILE_APP_HND): "Name=CONTEXT\FILE_APP, KfName=CONTEXT\FILE_APP.KEY, Shr",INTERNAL,INPUT,KEYED 
12130 LET OPEN_MASTER$=("") !:
      MAT OPEN_KEY$=("") !:
      READ #FILE_APP_HND,USING 12131,KEY=APPLICATION$&FILENAME$,RELEASE: APP_DATA$,OPEN_MASTER$,MAT OPEN_KEY$ IOERR 12190
12131 FORM POS 47,C 32,POS 89,10*C 64
12132 LET APP_DATA$=TRIM$(APP_DATA$) !:
      LET OPEN_MASTER$=TRIM$(OPEN_MASTER$) !:
      IF TRIM$(APP_DATA$)<>"" THEN LET APP_DATA$(999:0)="\"
12140 LET TEMP_TABLE_HANDLE=FNGETHANDLE_
12150 IF TRIM$(OPEN_KEY$(1))="" THEN !:
      OPEN #TEMP_TABLE_HANDLE: "NAME="&TRIM$(APP_DATA$&OPEN_MASTER$)&",shr",INTERNAL,OUTIN,RELATIVE IOERR 12190 !:
      MAT TABLE_HANDLES(_TABLE_HANDLE+=1) !:
      LET TABLE_HANDLES(_TABLE_HANDLE)=TEMP_TABLE_HANDLE !:
      GOTO 12185
12160 FOR _KEYS=1 TO 9
12170 IF TRIM$(OPEN_KEY$(_KEYS))<>"" THEN !:
      LET TEMP_TABLE_HANDLE=FNGETHANDLE_ !:
      OPEN #TEMP_TABLE_HANDLE: "NAME="&TRIM$(APP_DATA$&OPEN_MASTER$)&",KFNAME="&TRIM$(APP_DATA$&OPEN_KEY$(_KEYS))&",SHR",INTERNAL,OUTIN,KEYED IOERR 12180 !:
      MAT TABLE_HANDLES(_TABLE_HANDLE+=1) !:
      LET TABLE_HANDLES(_TABLE_HANDLE)=TEMP_TABLE_HANDLE
12180 NEXT _KEYS
12185 LET FNOPEN_TABLE=TABLE_HANDLES(1)
12189 GOTO 12199
12190 LET FNOPEN_TABLE=ERR*-1
12199 FNEND 
12702 DEF LIBRARY FNSTATUS_FILE(MAT NAME_FILE$,MAT KFNAME_FILE$,MAT USE_FILE$)
12704   LET FNSTATUS_FILE=FNSTATUSFILE(MAT NAME_FILE$,MAT KFNAME_FILE$,MAT USE_FILE$)
12706 FNEND 
12710 DEF FNSTATUSFILE(MAT NAME_FILE$,MAT KFNAME_FILE$,MAT USE_FILE$)
12720 LET MAX_FILES=0
12730 EXECUTE "STATUS FILE >"&ENV$("TEMP")&"ST-FILE.[WSID]"
12740 LET NWORKFILE=FNGETHANDLE_ !:
      OPEN #NWORKFILE: "NAME="&ENV$("TEMP")&"ST-FILE.[WSID]",DISPLAY,INPUT 
12750 LINPUT #NWORKFILE: BUFF$ EOF 12840 !:
      LET BUFF$=UPRC$(BUFF$)
12760 IF POS(BUFF$,"OPEN FILE #")<=0 THEN GOTO 12750
12770 LET FILE_HANDLE=VAL(BUFF$(12:16)) !:
      IF FILE_HANDLE=NWORKFILE THEN !:
      GOTO 12750 ELSE !:
      IF FILE_HANDLE=0 THEN GOTO 12750 !:
      ELSE IF FILE_HANDLE>UDIM(NAME_FILE$) THEN !:
      MAT NAME_FILE$(FILE_HANDLE): MAT KFNAME_FILE$(FILE_HANDLE): MAT USE_FILE$(FILE_HANDLE)
12771 IF UDIM(NAME_FILE$)<FILE_HANDLE THEN !:
      MAT NAME_FILE$(FILE_HANDLE) !:
      MAT KFNAME_FILE$(FILE_HANDLE) !:
      MAT USE_FILE$(FILE_HANDLE)
12772 LET NAME_FILE$(FILE_HANDLE)=TRIM$(BUFF$(17:999))
12773 IF FILE_HANDLE>MAX_FILES THEN LET MAX_FILES=FILE_HANDLE
12774 LET NSLASH=POS(NAME_FILE$(FILE_HANDLE),"\",-1) !:
      LET USE_FILE$(FILE_HANDLE)=UPRC$("NAME="&NAME_FILE$(FILE_HANDLE)(1:2)&NAME_FILE$(FILE_HANDLE)(NSLASH+1:999))
12780 LINPUT #NWORKFILE: BUFF$ !:
      LET BUFF$=UPRC$(BUFF$) !:
      IF TRIM$(BUFF$)="" THEN GOTO 12750
12790 LINPUT #NWORKFILE: BUFF$ !:
      LET BUFF$=UPRC$(BUFF$)
12791 IF TRIM$(BUFF$)="" THEN GOTO 12750
12792 LET NKEY_FILE=POS(UPRC$(BUFF$),"KEY FILE") !:
      IF NKEY_FILE<=0 THEN GOTO 12790 !:
      ! There are several types of "KEY FILES"
12801 LET KFNAME_FILE$(FILE_HANDLE)=TRIM$(BUFF$(NKEY_FILE+10:999))
12802 LET NSLASH=POS(KFNAME_FILE$(FILE_HANDLE),"\",-1) !:
      LET USE_FILE$(FILE_HANDLE)(9999:0)=UPRC$(",KFNAME="&KFNAME_FILE$(FILE_HANDLE)(1:2)&KFNAME_FILE$(FILE_HANDLE)(NSLASH+1:999))
12803 ! IF UPRC$(KFNAME_FILE$(FILE_HANDLE))<>KFNAME_FILE$(FILE_HANDLE) THEN PRINT "Warning: Problem with Index file Case!" !:
      ! PAUSE
12820 LINPUT #NWORKFILE: BUFF$ !:
      LET BUFF$=UPRC$(BUFF$)
12821 IF TRIM$(BUFF$)<>"" THEN GOTO 12820
12830 GOTO 12750
12840 CLOSE #NWORKFILE: 
12860 FNEND 
13000 ! DIM/Arrays for Managing the ODBC Context Database
13010 DIM APP_DATA$(1)*256,APP_DATA(1),APP_FIELDSC$(1)*256,APP_FIELDSN$(1)*256,APP_FORMC$*2048,APP_FORMN$*2048,APP_HANDLES(1),APP_FORM_ALL$*2048
13020 DIM CONTEXT_DATA$(1)*256,CONTEXT_DATA(1),CONTEXT_FIELDSC$(1)*256,CONTEXT_FIELDSN$(1)*256,CONTEXT_FORMC$*2048,CONTEXT_FORMN$*2048,CONTEXT_HANDLES(1),CONTEXT_FORM_ALL$*2048
13030 DIM FILE_APP_DATA$(1)*256,FILE_APP_DATA(1),FILE_APP_FIELDSC$(1)*256,FILE_APP_FIELDSN$(1)*256,FILE_APP_FORMC$*2048,FILE_APP_FORMN$*2048,FILE_APP_HANDLES(1),FILE_APP_FORM_ALL$*2048
13040 DIM RECORD_DATA$(1)*256,RECORD_DATA(1),RECORD_FIELDSC$(1)*256,RECORD_FIELDSN$(1)*256,RECORD_FORMC$*2048,RECORD_FORMN$*2048,RECORD_HANDLES(1),RECORD_FORM_ALL$*2048
13050 DIM REC_LINK_DATA$(1)*256,REC_LINK_DATA(1),REC_LINK_FIELDSC$(1)*256,REC_LINK_FIELDSN$(1)*256,REC_LINK_FORMC$*2048,REC_LINK_FORMN$*2048,REC_LINK_HANDLES(1),REC_LINK_FORM_ALL$*2048
14030 DEF FNGETHANDLE_
14031 LET NEXT_FILE_HANDLE=999
14032 IF RLN(NEXT_FILE_HANDLE)<=0 THEN GOTO 14035
14034 LET NEXT_FILE_HANDLE-=1 !:
      GOTO 14032
14035 LET FNGETHANDLE_=NEXT_FILE_HANDLE
14039 FNEND 
14050 DEF FNGETDISPLAY_(FILE_NAME$*256;TYPE$*50,NEW_USE_REPLACE$*50,SHR$*50)
14051 LET NEXT_FILE_HANDLE=200 !:
      IF TRIM$(FILE_NAME$)="" THEN PRINT "WARNING, BLANK FILE NAME PASSED"
14052 IF POS(UPRC$(FILE_NAME$),"NAME=")=0 THEN !:
      LET FILE_NAME$="NAME="&FILE_NAME$
14053 IF TRIM$(NEW_USE_REPLACE$)<>"" THEN !:
      LET FILE_NAME$=FILE_NAME$&","&NEW_USE_REPLACE$
14054 IF TRIM$(SHR$)<>"" THEN !:
      LET FILE_NAME$=FILE_NAME$&","&SHR$ ELSE !:
      LET FILE_NAME$=FILE_NAME$&",SHR"
14055 LET NEXT_FILE_HANDLE-=1 !:
      IF TRIM$(FILE$(NEXT_FILE_HANDLE))<>"" THEN GOTO 14055
14056 ! PAUSE
14060 IF TYPE$="" OR TYPE$="INPUT" THEN !:
      OPEN #NEXT_FILE_HANDLE: FILE_NAME$,DISPLAY,INPUT IOERR 14065 ELSE !:
      OPEN #NEXT_FILE_HANDLE: FILE_NAME$&",recl=1000",DISPLAY,OUTPUT IOERR 14065
14061 GOTO 14069
14065 LET NEXT_FILE_HANDLE=0
14069 LET FNGETDISPLAY_=NEXT_FILE_HANDLE
14070 FNEND 
16010 DEF LIBRARY FNCONTEXT(APPLICATION$,FILENAME$,ALIAS$,MAT DATA$,MAT DATA,MAT FIELDSC$,MAT FIELDSN$,&FORM_C$,&FORM_N$,&FORM_ALL$)
16011 DIM UNPACK_C$*2048,UNPACK_N$*2048,CONTEXT_KEY$*80,FDESC$*256,FTYPE$*20
16012 LET APPLICATION$=UPRC$(RPAD$(APPLICATION$,8)(1:8)) !:
      LET FILENAME$=UPRC$(RPAD$(FILENAME$,8)(1:8)) !:
      LET ALIAS$=UPRC$(RPAD$(ALIAS$,8)(1:8)) !:
      IF TRIM$(ALIAS$)="" THEN LET ALIAS$=FILENAME$ !:
      ! ** Alias is an optional parameter that will default to the File Name if left blank
16013 LET CONTEXT_KEY$=APPLICATION$&FILENAME$&ALIAS$
16020 DIM FORM$*4096, FORM1$*4096, F$(999)*30,F_NAME$(999)*40, F_POS(999), F_LEN(999), F_TYPE$(999)*20, LINE$*150,FORM_C$*4096,FORM_N$*4096
16021 IF CONTEXT_HND=0 THEN LET CONTEXT_HND=FNGETHANDLE_
16025 IF FILE(CONTEXT_HND)<0 THEN !:
      OPEN #(CONTEXT_HND): "Name=CONTEXT\CONTEXT, KfName=CONTEXT\CONTEXT.KEY, Shr",INTERNAL,INPUT,KEYED 
16026 FORM POS 1,3*C 8,C 15,C 20,3*C 8,C 30,X 36,BH 4,3*BH 2,9*BH 1,BH 3
16027 ! WRITE #1,USING 16026: MAT TINFO$,TLISTPOINT,TRPOS,TRLEN,TRDEC,MAT TKEYS,TDCHANGE !:
      ! ! 9 Tinfo Elements + TLISTPOINT,TRPOS
16040 LET FORM$="FORM " !:
      LET FORM1$="FORM "
16050 LET C_COUNT=0: LET N_COUNT=0
16070 LET FIELD_COUNT=1 !:
      LET RECORD_LEN=0
16080 LET LAST_POSITION=LAST_POSITION1=LAST_LENGTH=LAST_LENGTH1=0
16085 READ #CONTEXT_HND,USING 16091,SEARCH>=CONTEXT_KEY$,RELEASE: APP$,FIL$,ALI$,FIELD$,FTYPE$,FFORMAT$,C_F1$,C_F2$,FDESC$,FLP,FPOS,FLEN,FDEC NOKEY 16210 !:
      GOTO 16091
16090 READ #CONTEXT_HND,USING 16091,RELEASE: APP$,FIL$,ALI$,FIELD$,FTYPE$,FFORMAT$,C_F1$,C_F2$,FDESC$,FLP,FPOS,FLEN,FDEC EOF 16210
16091 FORM POS 1,3*C 8,C 15,C 20,3*C 8,C 30,X 36,BH 4,3*BH 2,9*BH 1,BH 3
16092 IF APP$<>APPLICATION$ OR FIL$<>FILENAME$ OR ALI$<>ALIAS$ THEN !:
      GOTO 16210
16100 LET _SPACE=POS(FTYPE$," ") !:
      IF _SPACE>0 THEN LET FTYPE$(_SPACE:999)="" !:
      ! ! FTYPE$ should be the type & only the type
16110 LET F$(FIELD_COUNT)=TRIM$(FIELD$) !:
      LET F_NAME$(FIELD_COUNT)=TRIM$(FDESC$) !:
      LET F_POS(FIELD_COUNT)=FPOS !:
      LET F_LEN(FIELD_COUNT)=VAL(STR$(FLEN+VAL("."&STR$(FDEC)))) !:
      LET F_TYPE$(FIELD_COUNT)=TRIM$(FTYPE$)
16115 IF UPRC$(F_TYPE$(FIELD_COUNT))="X" THEN !:
      GOTO 16090 !:
      !  ** X is just filler, simply ignore!
16120 IF F_TYPE$(FIELD_COUNT)="C" THEN !:
      GOTO 16130 ELSE !:
      IF F_TYPE$(FIELD_COUNT)="PIC(##/##/##)" OR F_TYPE$(FIELD_COUNT)="PIC(####/##/##)" THEN !:
      GOTO 16150 ELSE !:
      GOTO 16170
16130 LET C_COUNT+=1 : MAT FIELDSC$(C_COUNT) !:
      LET FIELDSC$(C_COUNT)=F$(FIELD_COUNT) !:
      IF LAST_POSITION+LAST_LENGTH<>F_POS(FIELD_COUNT) THEN !:
      LET FORM$=FORM$&"POS "&STR$(F_POS(FIELD_COUNT))&","&F_TYPE$(FIELD_COUNT)&" "&STR$(F_LEN(FIELD_COUNT))&"," ELSE !:
      LET FORM$=FORM$&F_TYPE$(FIELD_COUNT)&" "&STR$(F_LEN(FIELD_COUNT))&","
16140 GOTO 16180
16150 LET C_COUNT+=1 !:
      MAT FIELDSC$(C_COUNT): LET FIELDSC$(C_COUNT)=F$(FIELD_COUNT) !:
      IF LAST_POSITION+LAST_LENGTH<>F_POS(FIELD_COUNT) THEN !:
      LET FORM$=FORM$&"POS "&STR$(F_POS(FIELD_COUNT))&","&F_TYPE$(FIELD_COUNT)&"," ELSE !:
      LET FORM$=FORM$&F_TYPE$(FIELD_COUNT)&","
16160 GOTO 16180
16170 IF F_TYPE$(FIELD_COUNT)(1:3)="PIC" OR F_TYPE$(FIELD_COUNT)="L" THEN !:
      LET NUM_FIELD$=F_TYPE$(FIELD_COUNT) ELSE !:
      LET NUM_FIELD$=F_TYPE$(FIELD_COUNT)&" "&STR$(F_LEN(FIELD_COUNT))
16171  LET N_COUNT+=1: MAT FIELDSN$(N_COUNT) !:
       LET FIELDSN$(N_COUNT)=F$(FIELD_COUNT) !:
       IF LAST_POSITION1+LAST_LENGTH1<>F_POS(FIELD_COUNT) THEN !:
       LET FORM1$=FORM1$&"POS "&STR$(F_POS(FIELD_COUNT))&","&NUM_FIELD$&"," ELSE LET FORM1$=FORM1$&NUM_FIELD$&","
16180 IF F_TYPE$(FIELD_COUNT)="C" THEN !:
      LET LAST_POSITION=F_POS(FIELD_COUNT) !:
      LET LAST_LENGTH=F_LEN(FIELD_COUNT) ELSE !:
      IF F_TYPE$(FIELD_COUNT)="PIC(##/##/##)" OR F_TYPE$(FIELD_COUNT)="PIC(####/##/##)" THEN !:
      LET LAST_POSITION=F_POS(FIELD_COUNT) !:
      LET LAST_LENGTH=F_LEN(FIELD_COUNT) ELSE !:
      LET LAST_POSITION1=F_POS(FIELD_COUNT) !:
      LET LAST_LENGTH1=INT(F_LEN(FIELD_COUNT))
16190 ! PAUSE
16200 LET FIELD_COUNT+=1 !:
      IF FIELD_COUNT>999 THEN GOTO 16210 ELSE GOTO 16090
16210 LET N_SELECTED=C_COUNT: LET N_SELECTED1=N_COUNT
16220 LET FORM$=FORM$(1:LEN(FORM$)-1)
16230 LET FORM1$=FORM1$(1:LEN(FORM1$)-1)
16240 MAT DATA$(N_SELECTED) : MAT DATA(N_SELECTED1)
16250 CLOSE #FORM_FILE: 
16261 LET UNPACK_C$=FNPACKFORM$(FORM$,0) !:
      LET FORM_C$=FNPACKFORM$(FORM$,1)
16262 LET UNPACK_N$=FNPACKFORM$(FORM1$,0) !:
      LET FORM_N$=FNPACKFORM$(FORM1$,1)
16263 LET _POS=POS(UNPACK_N$," ") !:
      LET FORM_ALL$=CFORM$(TRIM$(UNPACK_C$)&","&TRIM$(UNPACK_N$)(_POS+1:9999)) !:
      LET FORM_ALL$=(TRIM$(UNPACK_C$)&","&TRIM$(UNPACK_N$)(_POS+1:9999))
16270 FNEND 
16651 DEF LIBRARY FNPACK_FORM$*1024(F$*2048;PACK_TYPE)
16652 LET FNPACK_FORM$=FNPACKFORM$(F$,PACK_TYPE)
16653 FNEND 
16660 DEF FNPACKFORM$*1024(F$*2048,PACK_TYPE)
16661 ! PACK_TYPE=1 - USE CFORM TO COMPILE !:
      ! PACK_TYPE=0 DO NOT USE CFORM TO COMPILE
16662 LET F$=SREP$(F$,"PIC(##/##/##)","C 8") !:
      LET F$=SREP$(F$,"PIC(####/##/##)","C 10")
16670 DIM TEMP$(350)*50,TF$*2048,PREVIOUS$*256
16680 LET TF$="": LET COUNT=1: LET PREVIOUS$=""
16690 LET I=1: MAT TEMP$=("")
16700 DO WHILE LEN(F$)>0
16702   LET FORM_COMMA_POS=POS(F$&",",",")
16710   IF FORM_COMMA_POS>0 THEN !:
        LET TEMP$(I)=F$(1:FORM_COMMA_POS-1) !:
        LET F$=F$(FORM_COMMA_POS+1:LEN(F$))
16720   IF I=1 THEN LET TF$=TEMP$(I): LET I+=1: GOTO 16800
16730   IF TEMP$(I)=PREVIOUS$ THEN LET COUNT+=1 : GOTO 16770
16740   IF PREVIOUS$(1:3)="POS" THEN LET TF$=TF$&","&PREVIOUS$: GOTO 16770
16750   IF I=2 THEN GOTO 16770
16760   IF COUNT=1 THEN !:
        LET TF$=TF$&","&PREVIOUS$ ELSE !:
        LET TF$=TF$&","&STR$(COUNT)&"*"&PREVIOUS$: LET COUNT=1
16770   LET I+=1
16780   LET PREVIOUS$=TEMP$(I-1)
16790   IF LEN(F$)<>0 THEN GOTO 16791 ELSE GOTO 16793
16791   IF POS(F$&",",",")=0 THEN GOTO 16810
16792   GOTO 16800
16793   IF POS(F$,",")=0 THEN GOTO 16810
16800 LOOP 
16810 IF COUNT=1 THEN !:
      LET TF$=TF$&","&PREVIOUS$&","&F$ ELSE !:
      LET TF$=TF$&","&STR$(COUNT)&"*"&PREVIOUS$&","&F$
16812 LET TF$=SREP$(TF$,",6*(N 2,BH 3,X 3,PD 6.2),POS 945,6*(BH 3,X 11),",",6*(N 2,BH 3,X 3,PD 6.2),POS 945,6*(BH 3,X 11),")
16813 LET TF$=FNFIXRPT$(TF$,"PIC($,$$$,$$$.##),C 1") !:
      LET TF$=FNFIXRPT$(TF$,"PIC($$,$$$,$$$.##-),C 1") !:
      LET TF$=FNFIXRPT$(TF$,"PIC(MM/DD/CCYY),C 1")
16814 LET TF$=SREP$(TF$,",N 2,2*BH 3,PD 6.2,N 2,2*BH 3,PD 6.2,N 2,2*BH 3,PD 6.2,N 2,2*BH 3,PD 6.2,N 2,2*BH 3,PD 6.2,N 2,2*BH 3,PD 6.2,",",6*(N 2,2*BH 3,PD 6.2),")
16815 LET TF$=SREP$(TF$,"C 3,C 4,C 3,C 4,C 3,C 4,C 3,C 4,C 3,C 4,C 3,C 4,C 3,C 4,C 3,C 4,C 3,C 4,C 3,C 4","10*(C 3,C 4)")
16820 LET TF$=RTRM$(TF$,",")
16821 IF TRIM$(TF$)="FORM" THEN LET FNPACKFORM$="" !:
      GOTO 16830
16825 IF PACK_TYPE AND LEN(TF$)<=470 THEN !:
      LET FNPACKFORM$=CFORM$(TF$) ELSE !:
      LET FNPACKFORM$=TF$
16830 FNEND 
16835 DEF FNFIXRPT$*2048(TF$*2048,STRIP$*256)
16836 LET TF$=SREP$(TF$,STRIP$&","&STRIP$&","&STRIP$&","&STRIP$&","&STRIP$&","&STRIP$,"6*("&STRIP$&")")
16837 LET TF$=SREP$(TF$,STRIP$&","&STRIP$&","&STRIP$&","&STRIP$&","&STRIP$,"5*("&STRIP$&")")
16838 LET TF$=SREP$(TF$,STRIP$&","&STRIP$&","&STRIP$&","&STRIP$,"4*("&STRIP$&")")
16839 LET TF$=SREP$(TF$,STRIP$&","&STRIP$&","&STRIP$,"3*("&STRIP$&")")
16840 LET TF$=SREP$(TF$,STRIP$&","&STRIP$,"2*("&STRIP$&")")
16848 LET FNFIXRPT$=TF$
16849 FNEND 
17000 DEF LIBRARY FNINDEX_HANDLE(INDEX_KEY$*80; ACCESS_RIGHT$, &RECORD_PRIOR)
17010 ! Index_Key$    = Valid values are like "Name=I:Master,KFName=I:MasterX"
17020 !                 use of File//# i.e. Master//6 will force the file to be reopened, even if it is already opened.
17030 !                 "Name=" and ",KFName=" are not optional.
17040 ! Access_Right$ = Valid values are "Input", "OutIn", or "Output", "Input" is the default if not specified.  This specifies if the file (if not already open) should be opened for OutIn/Input/Output
17050 ! Record_Prior  = Was the file already open?    -1: file was closed   =>0: file was already open and pointing to this record.
17060 ! 
17070   LET ACCESS_RIGHT$=UPRC$(TRIM$(ACCESS_RIGHT$))
17080   IF ACCESS_RIGHT$="" THEN LET ACCESS_RIGHT$="INPUT"
17090   LET IH_SEARCH_COUNT=0
17100 START_FNINDEX_HANDLE: ! 
17110   LET SET_FNINDEX_HANDLE=SRCH(MAT USE_FILE$,UPRC$(TRIM$(INDEX_KEY$)))
17120   LET RECORD_PRIOR=REC(SET_FNINDEX_HANDLE)
17130   LET IH_SEARCH_COUNT+=1
17140   IF (SET_FNINDEX_HANDLE=-1 OR FILE(SET_FNINDEX_HANDLE)=-1) AND IH_SEARCH_COUNT=1 THEN GOSUB SETUP_FNINDEX_HANDLE : GOTO START_FNINDEX_HANDLE
17150   IF (SET_FNINDEX_HANDLE=-1 OR FILE(SET_FNINDEX_HANDLE)=-1) AND IH_SEARCH_COUNT>1 THEN 
17160     IF ACCESS_RIGHT$="OUTPUT" THEN 
17170       OPEN #SET_FNINDEX_HANDLE:=FNGETHANDLE_: INDEX_KEY$&",Shr",INTERNAL,OUTPUT,KEYED IOERR IH_IOERR
17180      ELSE IF ACCESS_RIGHT$="OUTIN" THEN 
17190       OPEN #SET_FNINDEX_HANDLE:=FNGETHANDLE_: INDEX_KEY$&",Shr",INTERNAL,OUTIN,KEYED IOERR IH_IOERR
17200      ELSE 
17210       OPEN #SET_FNINDEX_HANDLE:=FNGETHANDLE_: INDEX_KEY$&",Shr",INTERNAL,INPUT,KEYED IOERR IH_IOERR
17220     END IF  ! Access_Right$="OUTPUT"   /   Access_Right$="OUTIN"   /   else 
17230   END IF  ! (Set_fnIndex_Handle=-1 or File(Set_fnIndex_Handle)=-1) and IH_Search_Count>1
17240   GOTO XIT_FNINDEX_HANDLE
17250 SETUP_FNINDEX_HANDLE: ! 
17260     DIM NAME_FILE$(1)*80,KFNAME_FILE$(1)*80,USE_FILE$(1)*80
17270     MAT NAME_FILE$(0) : MAT KFNAME_FILE$(0) : MAT USE_FILE$(0)
17280     LET FNSTATUSFILE(MAT NAME_FILE$,MAT KFNAME_FILE$,MAT USE_FILE$)
17290   RETURN 
17300 IH_IOERR: ! 
17310     LET SET_FNINDEX_HANDLE=-ERR
17320   GOTO XIT_FNINDEX_HANDLE
17330 XIT_FNINDEX_HANDLE: ! 
17340   LET FNINDEX_HANDLE=SET_FNINDEX_HANDLE
17350 FNEND 
30300 DEF LIBRARY FNOPEN_CSV(CSV_HANDLE,CSV$*80,&CSV_DELIMITER$,MAT CSV_FIELDS$,MAT CSV_DATA$)
30302 ! If there is an error opening this file the function will return the error number as a negative (and also 0 fields)
30310 IF FILE(CSV_HANDLE)>0 THEN CLOSE #CSV_HANDLE: 
30320 OPEN #CSV_HANDLE: "NAME="&TRIM$(CSV$),DISPLAY,INPUT IOERR OPEN_CSV_OPEN_ERR
30330 LINPUT #CSV_HANDLE: BUFF$
30340 IF POS(BUFF$,CHR$(9))>0 THEN LET CSV_DELIMITER$=CHR$(9) ELSE !:
      LET CSV_DELIMITER$=","
30350 LET FIELDS=FNLIST_(":"&BUFF$,MAT CSV_FIELDS$,CSV_DELIMITER$)
30351 FOR NFIX=1 TO UDIM(CSV_FIELDS$) !:
      LET CSV_FIELDS$(NFIX)=UPRC$(SREP$(CSV_FIELDS$(NFIX),"'","")) !:
      LET CSV_FIELDS$(NFIX)=UPRC$(SREP$(CSV_FIELDS$(NFIX),'"',"")) !:
      NEXT NFIX
30358 OPEN_CSV_FINIS: ! 
30360   LET FNOPEN_CSV=FIELDS !:
        MAT CSV_DATA$(FIELD)=("")
30370 GOTO OPEN_CSV_XIT
30380 OPEN_CSV_OPEN_ERR: ! 
30382   LET FIELDS=-ERR !:
        LET FIELD=0
30384 GOTO OPEN_CSV_FINIS
30390 OPEN_CSV_XIT: ! 
30399 FNEND 
43400 DEF FNLIST_(LIST$*4096,MAT WORK$;DELIMITER$)
43401 IF TRIM$(DELIMITER$)="" THEN LET DELIMITER$=","
43410 LET WORK=0 !:
      MAT WORK$(1)=("*!*") !:
      LET X=POS(LIST$,":") !:
      LET LIST$=TRIM$(LIST$(X+1:9999))&DELIMITER$
43420 LET X=POS(LIST$,DELIMITER$) !:
      LET WORK+=1 !:
      MAT WORK$(WORK) !:
      LET WORK$(WORK)=LIST$(1:X-1) !:
      LET LIST$=TRIM$(LIST$(X+1:9999))
43430 IF TRIM$(LIST$)<>DELIMITER$ AND TRIM$(LIST$)<>"" THEN GOTO 43420
43435 LET FNLIST_=WORK
43440 FNEND 
43445 DEF LIBRARY FNLIST(LIST$*4096,MAT WORK$;DELIMITER$)
43446 LET FNLIST=FNLIST_(LIST$,MAT WORK$,DELIMITER$)
43447 FNEND 
43600 DEF FNPARSE_CSV_(LIST$*3072,MAT WORK$;SEPARATOR$,NOTRIM)
43605 IF TRIM$(SEPARATOR$)="" THEN LET SEPARATOR$=","
43610 LET WORK=0 !:
      IF NOTRIM THEN LET LIST$=LIST$&SEPARATOR$ !:
      ELSE LET LIST$=TRIM$(LIST$)&SEPARATOR$
43615 LET DELIM$='' !:
      IF LIST$(1:1)='"' OR LIST$(1:1)="'" THEN LET DELIM$=LIST$(1:1) !:
      LET LIST$(1:1)=""
43620 LET XSTART=0 !:
      LET X_ADV=1 !:
      IF DELIM$<>"" THEN LET XSTART=POS(LIST$,DELIM$) !:
      LET X_ADV=2
43625 DO WHILE DELIM$<>"" AND LIST$(XSTART+1:XSTART+1)=DELIM$
43630  LET LIST$(XSTART+1:XSTART+1) = ""
43635  LET XSTART = POS(LIST$,DELIM$,XSTART+1)
43640 LOOP 
43645 LET X=POS(LIST$,SEPARATOR$,XSTART)
43650 LET WORK+=1 !:
      MAT WORK$(WORK) !:
      LET WORK$(WORK)=LIST$(1:X-X_ADV) !:
      IF NOTRIM=1 THEN LET LIST$=LIST$(X+1:9999) ELSE !:
      LET LIST$=TRIM$(LIST$(X+1:9999))
43654 ! We may want to parse further "\" variables in the future !:
      ! For example, we may want to remove trailing "\" fields.
43655 IF TRIM$(DELIM$)="" THEN 
43660   LET HEXPOS=1
43665   LET HEXPOS = POS(WORK$(WORK),"\x",HEXPOS)
43670   IF WORK$(WORK)(HEXPOS-1:HEXPOS-1)="\" THEN GOTO 43685
43675   IF HEXPOS=<0 THEN GOTO 43700
43680   LET CHRVAL = VAL(WORK$(WORK)(HEXPOS+2:HEXPOS+3)) CONV 43685 : GOTO 43690
43685   LET HEXPOS+=4 !:
        GOTO 43665
43690   LET WORK$(WORK)(HEXPOS:HEXPOS+3)=CHR$(CHRVAL)
43695   LET HEXPOS+=4 !:
        GOTO 43665
43700   LET WORK$(WORK) = SREP$(WORK$(WORK),"\\","\")
43705 END IF 
43710 IF TRIM$(LIST$)<>SEPARATOR$ AND TRIM$(LIST$)<>"" THEN GOTO 43615
43715 LET FNPARSE_CSV_=WORK
43720 FNEND 
43725 DEF LIBRARY FNPARSE_CSV(LIST$*3072,MAT WORK$;SEPARATER$,NOTRIM)
43730   LET FNPARSE_CSV=FNPARSE_CSV_(LIST$,MAT WORK$,SEPARATER$,NOTRIM)
43735 FNEND 
83338 DEF LIBRARY FNGET_VAR$*128(UNQ$, MAT FIELDSC$, MAT FIELDSN$)
83340 ! UNQ$ - Unique File Identifier ... ie Master, or Bank, or whatever - no spaces, this will be a part of a variable name, so keep it short, because your gonna be reusing it alot!
83350 ! these two arrays should be built by fnGet_FormArr and passed to this function
83360 ! MAT FIELDSC$ - This array will contain the names of the string fields contained in the file record.
83370 ! MAT FIELDSN$ - This array will contain the names of the numeric fields contained in the file record.
83374 DIM OUTLINE$*850
83375 LET MAXLINELENGTH=575 : LET PROCFILELINELEN=MAXLINELENGTH+50
83390 OPEN #PROCFILE:=FNGETHANDLE_: "Name="&ENV$("TEMP")&"Proc-"&SESSION$&".$$$,RecL="&STR$(PROCFILELINELEN)&",Size=0,Replace",DISPLAY,OUTPUT 
83400   FOR J=1 TO UDIM(FIELDSC$)+1
83410     IF LEN(OUTLINE$)>MAXLINELENGTH OR J>UDIM(FIELDSC$) THEN !:
          PRINT #PROCFILE: OUTLINE$(2:LEN(OUTLINE$)) : LET OUTLINE$=""
83412     IF J<=UDIM(FIELDSC$) THEN !:
          LET OUTLINE$(9999:0)=":Let "&UNQ$&"_"&SREP$(FIELDSC$(J),"#","")&"="&STR$(J)
83420   NEXT J
83430   FOR J=1 TO UDIM(FIELDSN$)+1
83440     IF LEN(OUTLINE$)>MAXLINELENGTH OR J>UDIM(FIELDSN$) THEN !:
          PRINT #PROCFILE: OUTLINE$(2:LEN(OUTLINE$)) : LET OUTLINE$=""
83442     IF J<=UDIM(FIELDSN$) THEN !:
          LET OUTLINE$(9999:0)=":Let "&UNQ$&"_"&SREP$(FIELDSN$(J),"#","")&"="&STR$(J)
83450   NEXT J
83460   LET FNGET_VAR$="*"&FILE$(PROCFILE)
83470 CLOSE #PROCFILE: 
83480 FNEND 
